AutoMerge
===

Overview
---
This newsletter article, [Living on the Edge - Automated Merging](https://swarm.workshop.perforce.com/view/automerge/main/docs/LivingOnTheEdge-AutomaticMerging.html), gives s sense of what AutoMerge is all about.

Project Status
---
This implementation was developed by Alan Petersen in 2012.  Contact [Perforce Consulting](mailto:consulting-helix-core@perforce.com) if you have any questions.

The code herein is a sample implemenation derived from code that was used to deploy a production solution during a consulting engagement.

This is sample code for reference only.  It is not presently documented and does not have installation documentation or automation.  (The live production solution is documented of course, but contains custom and proprietary content).

We expect to add docs and update the code.  That can happen a lot faster if we know someone is actively considering using it, so please do let us know if that's the case.

Bugs, Enhancements, and Future Plans
---

There is no formal roadmap for AutoMerge.  Comment on the project if you'd like to see more!

This implementation works with Perforce Classic only; it does not work with Streams.  Adding streams seems a natural next step.


Contributing
===
Contributions to the AutoMerge are most welcome!  Note that contributing requires a basic user knowledge of working with Perforce.


Contributing by Shelving
---

All registered Workshop users have **open** access (but not **write**), specifically to this path:

	//automerge/dev/...

The **open** access level confers the ability to edit and **shelve** changes for a pre-commit review process.  We'll review the change, and either incorporate it or provide feedback. Be sure to provide a detailed change description, and also include the tag/text "[review]" in your changelist description to initiate a Swarm code review.

Contributing by Branching
---
Optionally, you may request a personal development stream. Contact [Perforce Consulting](mailto:consulting-helix-core@perforce.com) to request a personal development stream.

Guidelines for SDP Contributors
---

* Communicate using Swarm!  Let folks know what you're planning before you work too hard on something that might already be underway.

Relationship to the Server Deployment Package
---

The [Perforce Server Deployment Package (SDP)](https://swarm.workshop.perforce.com/projects/perforce-software-sdp) is software designed to manage a Helix Versioning Engine (P4D) and other Helix components.

AutoMerge has no direct dependency on the SDP.  However, using the SDP can simplfy deployment.  Among other things, the SDP enshrines a home for the scripts (/p4/common/site/automerge), handles mechanics of defining shell environment in the cron wrapper script, installing the right version of Python, etc.

Some path examples in AutoMerge use SDP-style paths, e.g. /p4/common/bin and /p4/1/logs.
